//AgameR Fireworks Mod PE by peacestorm

/**
 * #############################
 * @name AgameR Fireworks Mod PE
 * @version v1.0
 * @author peacestorm
 * #############################
 **/

// ###########################
// MOD FUNCTIONS AND VARIABLES
// ###########################

var FireworksModPE = {};

const CURRENT_VERSION = "1.0";
var latestVersion;
var latestPocketEditionVersion;

const FIREWORK_ROCKET_ID = 1000;
const FIREWORK_FOUNTAIN_ID = 1001;

ModPE.setItem(FIREWORK_ROCKET_ID, "fireworks", 0, "Firework Rocket");
ModPE.setItem(FIREWORK_FOUNTAIN_ID, "fireworks", 0, "Firework Fountain");

FireworksModPE.clientMessage = function(text) {
	clientMessage(ChatColor.RED + "[AgameR Fireworks Mod PE] " + ChatColor.WHITE + text);
}

FireworksModPE.initCreativeItems = function() {
	Player.addItemCreativeInv(FIREWORK_ROCKET_ID, 1, 0);
	Player.addItemCreativeInv(FIREWORK_FOUNTAIN_ID, 1, 0);
}

FireworksModPE.getLatestVersion = function() {
    try {
        // download content
        var url = new java.net.URL("https://raw.githubusercontent.com/peacestorm/ModPE-scripts/master/version/agamer-fireworksmodpe-version");
        var connection = url.openConnection();

        // get content
        inputStream = connection.getInputStream();

        // read result
        var loadedVersion = "";
        var bufferedVersionReader = new java.io.BufferedReader(new java.io.InputStreamReader(inputStream));
        var rowVersion = "";
        while((rowVersion = bufferedVersionReader.readLine()) != null) {
            loadedVersion += rowVersion;
        }
        latestVersion = loadedVersion.split(" ")[0];
        latestPocketEditionVersion = loadedVersion.split(" ")[1];

        // close what needs to be closed
        bufferedVersionReader.close();

        // test
        //clientMessage(CURRENT_VERSION + " " + latestVersion);
    } catch(err) {
        clientMessage(ChatColor.BLUE + "[AgameR Fireworks Mod PE]" + ChatColor.WHITE + " Can't check for updates, please check your Internet connection.");
        ModPE.log("[AgameR Fireworks Mod PE] FireworksModPE.getLatestVersion() caught an error: " + err);
    }
}

function random(min, max) {
	return Math.floor((Math.random() * max) + min);
}

var ctx = com.mojang.minecraftpe.MainActivity.currentMainActivity.get();

var tts = new android.speech.tts.TextToSpeech(ctx, new android.speech.tts.TextToSpeech.OnInitListener({
	onInit: function(status) {
		tts.setLanguage(java.util.Locale.US);
	}
}));

// ########################
// HOOKS AND INITIALIZATION
// ########################

var FIREWORK_ROCKET_COUNTER = 0;
var FIREWORK_ROCKET_ISPLACED = false;
var FIREWORK_ROCKET_X, FIREWORK_ROCKET_Y, FIREWORK_ROCKET_Z, FIREWORK_ROCKET_SIDE;

var FIREWORK_FOUNTAIN_COUNTER = 0;
var FIREWORK_FOUNTAIN_ISPLACED = false;
var FIREWORK_FOUNTAIN_X, FIREWORK_FOUNTAIN_Y, FIREWORK_FOUNTAIN_Z, FIREWORK_FOUNTAIN_SIDE;

function newLevel() {
	FireworksModPE.initCreativeItems();
	FireworksModPE.clientMessage("Mod Initialized!");
	new java.lang.Thread(new java.lang.Runnable() {
        run: function() {
            FireworksModPE.getLatestVersion();
            if (latestVersion != CURRENT_VERSION && latestVersion != undefined) {
                clientMessage(ChatColor.RED + "[AgameR Fireworks Mod PE]" + ChatColor.WHITE + " There is a new version available (v" + latestVersion + " for Minecraft Pocket Edition v" + latestPocketEditionVersion + ")!");
            } else {
                ctx.runOnUiThread(new java.lang.Runnable() {
                    run: function() {
                        android.widget.Toast.makeText(ctx, new android.text.Html.fromHtml("<b>AgameR Fireworks Mod PE</b> You have the latest version"), 0).show();
                    }
                });
            }
        }
    }).start();
	//tts.speak("Happy new year!", android.speech.tts.TextToSpeech.QUEUE_FLUSH, null);
	FIREWORK_ROCKET_COUNTER = 0;
}

function useItem(x, y, z, itemId, blockId, side, data) {
	switch(itemId) {
		case FIREWORK_ROCKET_ID: {
			FIREWORK_ROCKET_COUNTER = 0;
			FIREWORK_ROCKET_ISPLACED = true;
			FIREWORK_ROCKET_X = x;
			FIREWORK_ROCKET_Y = y;
			FIREWORK_ROCKET_Z = z;
			FIREWORK_ROCKET_SIDE = side;
			break;
		}case FIREWORK_FOUNTAIN_ID: {
			FIREWORK_FOUNTAIN_COUNTER = 0;
			FIREWORK_FOUNTAIN_ISPLACED = true;
			FIREWORK_FOUNTAIN_X = x;
			FIREWORK_FOUNTAIN_Y = y;
			FIREWORK_FOUNTAIN_Z = z;
			FIREWORK_FOUNTAIN_SIDE = side;
			break;
		}
	}
}

function modTick() {
	if(FIREWORK_ROCKET_ISPLACED == true) {
		FIREWORK_ROCKET_COUNTER++;
		if(FIREWORK_ROCKET_COUNTER > 0 && FIREWORK_ROCKET_COUNTER < 180) {
			Level.addParticle(ParticleType.flame, FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, 0, 0, 0, 100);
			Level.playSound(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, "mob.creeper", 100, 0);
		}
		if(FIREWORK_ROCKET_COUNTER > 180 && FIREWORK_ROCKET_COUNTER < 201) {
			Level.addParticle(ParticleType.flame, FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, 0, 0, 0, 100);
			Level.playSound(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, "mob.creeper", 100, 0);
			if(getTile(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5) == 0) {
				Level.setTile(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, 35, random(0, 16));
				Level.destroyBlock(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, false);
			}
		}
		if(FIREWORK_ROCKET_COUNTER == 201) {
			Level.addParticle(ParticleType.flame, FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, 0, 0, 0, 100);
			Level.playSound(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, "random.explode", 100, 0);
			Level.explode(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, 1);
			if(getTile(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5) == 0) {
				Level.setTile(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, 35, random(0, 16));
				Level.destroyBlock(FIREWORK_ROCKET_X-(FIREWORK_ROCKET_SIDE==4?1:0)+(FIREWORK_ROCKET_SIDE==5?1:0)+0.5,(FIREWORK_ROCKET_Y-(FIREWORK_ROCKET_SIDE==0?1:0)+(FIREWORK_ROCKET_SIDE==1?1:0)+0.5)+FIREWORK_ROCKET_COUNTER/10,FIREWORK_ROCKET_Z-(FIREWORK_ROCKET_SIDE==2?1:0)+(FIREWORK_ROCKET_SIDE==3?1:0)+0.5, false);
			}
			FIREWORK_ROCKET_ISPLACED = false;
			FIREWORK_ROCKET_COUNTER = 0;
		}
	}if(FIREWORK_FOUNTAIN_ISPLACED == true) {
		FIREWORK_FOUNTAIN_COUNTER++;
		if(FIREWORK_FOUNTAIN_COUNTER > 0 && FIREWORK_FOUNTAIN_COUNTER < 100) {
			Level.addParticle(ParticleType.flame, FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, 0, 0, 0, 100);
			Level.playSound(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, "mob.creeper", 100, 0);
			if(getTile(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5) == 0) {
				Level.setTile(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, 35, random(0, 16));
				Level.destroyBlock(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, false);
			}
		}
		if(FIREWORK_FOUNTAIN_COUNTER == 101) {
			Level.addParticle(ParticleType.flame, FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, 0, 0, 0, 100);
			Level.playSound(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, "random.explode", 100, 0);
			if(getTile(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5) == 0) {
				Level.setTile(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, 35, random(0, 16));
				Level.destroyBlock(FIREWORK_FOUNTAIN_X-(FIREWORK_FOUNTAIN_SIDE==4?1:0)+(FIREWORK_FOUNTAIN_SIDE==5?1:0)+0.5,(FIREWORK_FOUNTAIN_Y-(FIREWORK_FOUNTAIN_SIDE==0?1:0)+(FIREWORK_FOUNTAIN_SIDE==1?1:0)+0.5)+2,FIREWORK_FOUNTAIN_Z-(FIREWORK_FOUNTAIN_SIDE==2?1:0)+(FIREWORK_FOUNTAIN_SIDE==3?1:0)+0.5, false);
			}
			FIREWORK_FOUNTAIN_ISPLACED = false;
			FIREWORK_FOUNTAIN_COUNTER = 0;
		}
	}
}